package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_1_1_Pathfinder extends ActorScript
{
	public var _Path:Array<Dynamic>;
	public var _LowestIndex:Float;
	public var _LowestIndexEnd:Float;
	public var _CoordinatesList:Array<Dynamic>;
	public var _ConnectionsList:Array<Dynamic>;
	public var _GetPathfindNodes:Bool;
	public var _DistanceLowest:Float;
	public var _PathColor:Int;
	public var _Radius:Float;
	public var _Debug:Bool;
	public var _NextIndex:Float;
	public var _ClosedNodes:Array<Dynamic>;
	public var _ClosedCount:Float;
	public var _RerouteCount:Float;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_Pathfind(__Xposition:Float, __Yposition:Float):Array<Dynamic>
	{
		var __Self:Actor = actor;
		_RerouteCount = asNumber(0);
		propertyChanged("_RerouteCount", _RerouteCount);
		Utils.clear(_Path);
		_Path = new Array<Dynamic>();
		propertyChanged("_Path", _Path);
		Utils.clear(_ClosedNodes);
		_ClosedNodes = new Array<Dynamic>();
		propertyChanged("_ClosedNodes", _ClosedNodes);
		/* Get index closest to actor */
		_DistanceLowest = asNumber(999999);
		propertyChanged("_DistanceLowest", _DistanceLowest);
		for(index0 in 0...Std.int(_CoordinatesList.length))
		{
			if((_DistanceLowest > Math.sqrt((Math.pow((actor.getXCenter() - asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(0)])), 2) + Math.pow((actor.getYCenter() - asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(1)])), 2)))))
			{
				_DistanceLowest = asNumber(Math.sqrt((Math.pow((actor.getXCenter() - asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(0)])), 2) + Math.pow((actor.getYCenter() - asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(1)])), 2))));
				propertyChanged("_DistanceLowest", _DistanceLowest);
				_LowestIndex = asNumber(index0);
				propertyChanged("_LowestIndex", _LowestIndex);
			}
		}
		if(!(Utils.contains(_ClosedNodes, _LowestIndex)))
		{
			_ClosedNodes.push(_LowestIndex);
		}
		/* Get index closest to destination */
		_DistanceLowest = asNumber(999999);
		propertyChanged("_DistanceLowest", _DistanceLowest);
		for(index0 in 0...Std.int(_CoordinatesList.length))
		{
			if((_DistanceLowest > Math.sqrt((Math.pow((__Xposition - asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(0)])), 2) + Math.pow((__Yposition - asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(1)])), 2)))))
			{
				_DistanceLowest = asNumber(Math.sqrt((Math.pow((__Xposition - asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(0)])), 2) + Math.pow((__Yposition - asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(1)])), 2))));
				propertyChanged("_DistanceLowest", _DistanceLowest);
				_LowestIndexEnd = asNumber(index0);
				propertyChanged("_LowestIndexEnd", _LowestIndexEnd);
			}
		}
		/* Build Path */
		/* Add closest to actor */
		_Path.push(_CoordinatesList[Std.int(_LowestIndex)]);
		/* Loop through connections, get closest to destination, move on. */
		for(index0 in 0...Std.int((_CoordinatesList.length * 2)))
		{
			_DistanceLowest = asNumber(999999);
			propertyChanged("_DistanceLowest", _DistanceLowest);
			if(!((_LowestIndex == _LowestIndexEnd)))
			{
				if((index0 == 0))
				{
					/* First node */
					for(item in cast(("" + _ConnectionsList[Std.int(_LowestIndex)]).split(","), Array<Dynamic>))
					{
						if((_DistanceLowest > Math.sqrt((Math.pow((__Xposition - asNumber(("" + _CoordinatesList[Std.int(item)]).split(",")[Std.int(0)])), 2) + Math.pow((__Yposition - asNumber(("" + _CoordinatesList[Std.int(item)]).split(",")[Std.int(1)])), 2)))))
						{
							_DistanceLowest = asNumber(Math.sqrt((Math.pow((__Xposition - asNumber(("" + _CoordinatesList[Std.int(item)]).split(",")[Std.int(0)])), 2) + Math.pow((__Yposition - asNumber(("" + _CoordinatesList[Std.int(item)]).split(",")[Std.int(1)])), 2))));
							propertyChanged("_DistanceLowest", _DistanceLowest);
							_NextIndex = asNumber(item);
							propertyChanged("_NextIndex", _NextIndex);
						}
					}
					_Path.push(_CoordinatesList[Std.int(_NextIndex)]);
					_ClosedNodes.push(_NextIndex);
				}
				else
				{
					trace("" + "===");
					trace("" + _CoordinatesList[Std.int(_NextIndex)]);
					if((_NextIndex == _LowestIndexEnd))
					{
						/* Final node */
						break;
					}
					else
					{
						/* Other nodes */
						_ClosedCount = asNumber(0);
						propertyChanged("_ClosedCount", _ClosedCount);
						for(item in cast(("" + _ConnectionsList[Std.int(_NextIndex)]).split(","), Array<Dynamic>))
						{
							/* Check if how many connections are closed */
							if(Utils.contains(_ClosedNodes, item))
							{
								_ClosedCount += 1;
								propertyChanged("_ClosedCount", _ClosedCount);
							}
						}
						/* Reroute */
						if(((_ClosedCount == ("" + _ConnectionsList[Std.int(_NextIndex)]).split(",").length) && !((_NextIndex == _LowestIndexEnd))))
						{
							_Path.remove(_CoordinatesList[Std.int(_NextIndex)]);
							_NextIndex = asNumber(_ClosedNodes[Std.int(((_ClosedNodes.length - 1) - _RerouteCount))]);
							propertyChanged("_NextIndex", _NextIndex);
							_RerouteCount += 1;
							propertyChanged("_RerouteCount", _RerouteCount);
						}
						else
						{
							_DistanceLowest = asNumber(999999);
							propertyChanged("_DistanceLowest", _DistanceLowest);
							for(item in cast(("" + _ConnectionsList[Std.int(_NextIndex)]).split(","), Array<Dynamic>))
							{
								/* Next Closest */
								if((!(Utils.contains(_ClosedNodes, item)) && (_DistanceLowest > Math.sqrt((Math.pow((__Xposition - asNumber(("" + _CoordinatesList[Std.int(item)]).split(",")[Std.int(0)])), 2) + Math.pow((__Yposition - asNumber(("" + _CoordinatesList[Std.int(item)]).split(",")[Std.int(1)])), 2))))))
								{
									_DistanceLowest = asNumber(Math.sqrt((Math.pow((__Xposition - asNumber(("" + _CoordinatesList[Std.int(item)]).split(",")[Std.int(0)])), 2) + Math.pow((__Yposition - asNumber(("" + _CoordinatesList[Std.int(item)]).split(",")[Std.int(1)])), 2))));
									propertyChanged("_DistanceLowest", _DistanceLowest);
									_NextIndex = asNumber(item);
									propertyChanged("_NextIndex", _NextIndex);
								}
							}
							/* Add node */
							if(!(Utils.contains(_ClosedNodes, _NextIndex)))
							{
								_Path.push(_CoordinatesList[Std.int(_NextIndex)]);
								_ClosedNodes.push(_NextIndex);
								_RerouteCount = asNumber(0);
								propertyChanged("_RerouteCount", _RerouteCount);
							}
						}
					}
				}
			}
			else
			{
				break;
			}
		}
		/* Add the point closest to the destination */
		_Path.push(_CoordinatesList[Std.int(_LowestIndexEnd)]);
		/* End: add desired point */
		_Path.push((("" + ("" + __Xposition)) + ("" + (("" + ",") + ("" + ("" + __Yposition))))));
		/* If no end path was found, return an empty list */
		if((!((_NextIndex == _LowestIndexEnd)) && !((_LowestIndex == _LowestIndexEnd))))
		{
			Utils.clear(_Path);
			_Path = new Array<Dynamic>();
			propertyChanged("_Path", _Path);
		}
		return _Path;
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Path", "_Path");
		_Path = [];
		nameMap.set("Lowest Index", "_LowestIndex");
		_LowestIndex = 0.0;
		nameMap.set("Lowest Index End", "_LowestIndexEnd");
		_LowestIndexEnd = 0.0;
		nameMap.set("Coordinates List", "_CoordinatesList");
		_CoordinatesList = [];
		nameMap.set("Connections List", "_ConnectionsList");
		_ConnectionsList = [];
		nameMap.set("Get Pathfind Nodes", "_GetPathfindNodes");
		_GetPathfindNodes = false;
		nameMap.set("Distance Lowest", "_DistanceLowest");
		_DistanceLowest = 0.0;
		nameMap.set("Path Color", "_PathColor");
		_PathColor = Utils.getColorRGB(255,153,0);
		nameMap.set("Radius", "_Radius");
		_Radius = 5.0;
		nameMap.set("Debug", "_Debug");
		_Debug = false;
		nameMap.set("Next Index", "_NextIndex");
		_NextIndex = 0.0;
		nameMap.set("Closed Nodes", "_ClosedNodes");
		_ClosedNodes = [];
		nameMap.set("Closed Count", "_ClosedCount");
		_ClosedCount = 0.0;
		nameMap.set("Reroute Count", "_RerouteCount");
		_RerouteCount = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(!(_GetPathfindNodes))
				{
					_GetPathfindNodes = true;
					propertyChanged("_GetPathfindNodes", _GetPathfindNodes);
					_Path = new Array<Dynamic>();
					propertyChanged("_Path", _Path);
					_ClosedNodes = new Array<Dynamic>();
					propertyChanged("_ClosedNodes", _ClosedNodes);
					if(sceneHasBehavior("Pathfinder Nodes"))
					{
						_CoordinatesList = getValueForScene("Pathfinder Nodes", "_CoordinatesList");
						propertyChanged("_CoordinatesList", _CoordinatesList);
						_ConnectionsList = getValueForScene("Pathfinder Nodes", "_ConnectionsList");
						propertyChanged("_ConnectionsList", _ConnectionsList);
					}
				}
			}
		});
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(_Debug)
				{
					g.translateToScreen();
					for(index0 in 0...Std.int(_Path.length))
					{
						g.drawString("" + _Path[Std.int(index0)], 3, (20 * index0));
					}
					for(item in cast(_Path, Array<Dynamic>))
					{
						g.strokeColor = _PathColor;
						g.fillColor = _PathColor;
						g.fillCircle(Math.round((asNumber(("" + item).split(",")[Std.int(0)]) - getScreenX())), Math.round((asNumber(("" + item).split(",")[Std.int(1)]) - getScreenY())), _Radius);
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}