package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_3_3_PathfinderNodes extends SceneScript
{
	public var _NodesList:Array<Dynamic>;
	public var _Debug:Bool;
	public var _LineColor:Int;
	public var _NodeColor:Int;
	public var _Radius:Float;
	public var _CoordinatesList:Array<Dynamic>;
	public var _ConnectionsList:Array<Dynamic>;
	public var _RowNumber:Float;
	public var _GenerateNodes:Bool;
	public var _NodeProperties:Array<Dynamic>;
	public var _JumpHeightinTiles:Float;
	public var _LoopIndex:Float;
	public var _MaxConnections:Float;
	public var _JumpRangeinTiles:Float;
	public var _BlockedNodes:Array<Dynamic>;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_JumpNodes():Void
	{
		for(index0 in 0...Std.int(_NodesList.length))
		{
			/* current node is lower or equal height than checked node */
			if((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) >= asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(1)])))
			{
				/* checked node is 0,3,4,6 or 7 and position of current node */
				if(((0 == asNumber(_NodeProperties[Std.int(index0)])) || (((3 == asNumber(_NodeProperties[Std.int(index0)])) && (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) < asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) || (((4 == asNumber(_NodeProperties[Std.int(index0)])) && (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) < asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) || (((6 == asNumber(_NodeProperties[Std.int(index0)])) && (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) > asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) || ((7 == asNumber(_NodeProperties[Std.int(index0)])) && (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) > asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))))))))
				{
					/* Tile distance */
					if(((((getTileWidth() * _JumpRangeinTiles) >= Math.abs((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) - asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)])))) && (getTileWidth() <= Math.abs((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) - asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))))) && (((getTileHeight() * _JumpHeightinTiles) >= Math.abs((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) - asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(1)])))) && (0 <= Math.abs((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) - asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(1)])))))))
					{
						if(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(1)]) == (""))
						{
							_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + index0));
						}
						else
						{
							if(!(Utils.contains(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(1)]).split(","), index0)))
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + (("" + ",") + ("" + index0))));
							}
						}
						/* reciprocate nodes */
						if(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(1)]) == (""))
						{
							_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + _LoopIndex));
						}
						else
						{
							if(!(Utils.contains(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(1)]).split(","), _LoopIndex)))
							{
								_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (("" + ",") + ("" + _LoopIndex))));
							}
						}
					}
				}
			}
		}
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_JumpNodesMiddle():Void
	{
		for(index0 in 0...Std.int(_NodesList.length))
		{
			/* current node is lower or equal height than checked node */
			if((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) > asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(1)])))
			{
				/* checked node is 0,3,4,6 or 7 and position of current node */
				if(((0 == asNumber(_NodeProperties[Std.int(index0)])) || (((3 == asNumber(_NodeProperties[Std.int(index0)])) && (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) < asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) || (((4 == asNumber(_NodeProperties[Std.int(index0)])) && (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) < asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) || (((6 == asNumber(_NodeProperties[Std.int(index0)])) && (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) > asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) || ((7 == asNumber(_NodeProperties[Std.int(index0)])) && (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) > asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))))))))
				{
					/* Tile distance */
					if(((((getTileWidth() * _JumpRangeinTiles) >= Math.abs((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) - asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)])))) && (getTileWidth() <= Math.abs((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) - asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))))) && (((getTileHeight() * _JumpHeightinTiles) >= Math.abs((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) - asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(1)])))) && (getTileHeight() <= Math.abs((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) - asNumber(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(0)]).split(",")[Std.int(1)])))))))
					{
						if(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(1)]) == (""))
						{
							_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + index0));
						}
						else
						{
							if(!(Utils.contains(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(1)]).split(","), index0)))
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + (("" + ",") + ("" + index0))));
							}
						}
						/* reciprocate nodes */
						if(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(1)]) == (""))
						{
							_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + _LoopIndex));
						}
						else
						{
							if(!(Utils.contains(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(1)]).split(","), _LoopIndex)))
							{
								_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (("" + ",") + ("" + _LoopIndex))));
							}
						}
					}
				}
			}
		}
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("Nodes List", "_NodesList");
		_NodesList = [];
		nameMap.set("Debug", "_Debug");
		_Debug = false;
		nameMap.set("Line Color", "_LineColor");
		_LineColor = Utils.getColorRGB(0,255,0);
		nameMap.set("Node Color", "_NodeColor");
		_NodeColor = Utils.getColorRGB(255,0,0);
		nameMap.set("Radius", "_Radius");
		_Radius = 3.0;
		nameMap.set("Coordinates List", "_CoordinatesList");
		_CoordinatesList = [];
		nameMap.set("Connections List", "_ConnectionsList");
		_ConnectionsList = [];
		nameMap.set("Row Number", "_RowNumber");
		_RowNumber = 0.0;
		nameMap.set("Generate Nodes", "_GenerateNodes");
		_GenerateNodes = true;
		nameMap.set("Node Properties", "_NodeProperties");
		_NodeProperties = [];
		nameMap.set("Jump Height in Tiles", "_JumpHeightinTiles");
		_JumpHeightinTiles = 3.0;
		nameMap.set("Loop Index", "_LoopIndex");
		_LoopIndex = 0.0;
		nameMap.set("Max Connections", "_MaxConnections");
		_MaxConnections = 0.0;
		nameMap.set("Jump Range in Tiles", "_JumpRangeinTiles");
		_JumpRangeinTiles = 4.0;
		nameMap.set("Blocked Nodes", "_BlockedNodes");
		_BlockedNodes = [];
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		if(_GenerateNodes)
		{
			_NodesList = new Array<Dynamic>();
			propertyChanged("_NodesList", _NodesList);
			_NodeProperties = new Array<Dynamic>();
			propertyChanged("_NodeProperties", _NodeProperties);
			/* Add nodes */
			for(index0 in 0...Std.int((getSceneHeight()/getTileHeight())))
			{
				_RowNumber = asNumber(index0);
				propertyChanged("_RowNumber", _RowNumber);
				for(index1 in 0...Std.int((getSceneWidth()/getTileWidth())))
				{
					if(((tileCollisionAt(Std.int((_RowNumber + 1)),Std.int(index1),0,"" + "-1") && !(tileCollisionAt(Std.int(_RowNumber),Std.int(index1),0,"" + "-1"))) && !(Utils.contains(_BlockedNodes, (("" + ("" + _RowNumber)) + ("" + (("" + ",") + ("" + ("" + index1)))))))))
					{
						_NodesList.push((("" + (("" + ((index1 * getTileWidth()) + (getTileWidth() / 2))) + ("" + (("" + ",") + ("" + ((_RowNumber * getTileHeight()) + (getTileWidth() / 2))))))) + ("" + "/")));
						/* Node properties */
						/* 0=solo */
						if(((!(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 + 1)),0,"" + "-1")) && !(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 - 1)),0,"" + "-1"))) && (!(tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 - 1)),0,"" + "-1")) && !(tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 + 1)),0,"" + "-1")))))
						{
							_NodeProperties.push(0);
						}
						/* 1=nook */
						if(((tileCollisionAt(Std.int(_RowNumber),Std.int((index1 + 1)),0,"" + "-1") && tileCollisionAt(Std.int(_RowNumber),Std.int((index1 - 1)),0,"" + "-1")) && (tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 - 1)),0,"" + "-1") && tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 + 1)),0,"" + "-1"))))
						{
							_NodeProperties.push(1);
						}
						/* 2=left end */
						if(((!(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 + 1)),0,"" + "-1")) && tileCollisionAt(Std.int(_RowNumber),Std.int((index1 - 1)),0,"" + "-1")) && (tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 - 1)),0,"" + "-1") && tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 + 1)),0,"" + "-1"))))
						{
							_NodeProperties.push(2);
						}
						/* 3=left edge solo */
						if((!(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 - 1)),0,"" + "-1")) && (!(tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 - 1)),0,"" + "-1")) && (tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 + 1)),0,"" + "-1") && tileCollisionAt(Std.int(_RowNumber),Std.int((index1 + 1)),0,"" + "-1")))))
						{
							_NodeProperties.push(3);
						}
						/* 4=left edge continuous */
						if(((!(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 - 1)),0,"" + "-1")) && !(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 + 1)),0,"" + "-1"))) && (tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 + 1)),0,"" + "-1") && !(tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 - 1)),0,"" + "-1")))))
						{
							_NodeProperties.push(4);
						}
						/* 5=right end */
						if(((tileCollisionAt(Std.int(_RowNumber),Std.int((index1 + 1)),0,"" + "-1") && tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 + 1)),0,"" + "-1")) && (!(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 - 1)),0,"" + "-1")) && tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 - 1)),0,"" + "-1"))))
						{
							_NodeProperties.push(5);
						}
						/* 6=right edge solo */
						if(((!(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 + 1)),0,"" + "-1")) && !(tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 + 1)),0,"" + "-1"))) && (tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 - 1)),0,"" + "-1") && tileCollisionAt(Std.int(_RowNumber),Std.int((index1 - 1)),0,"" + "-1"))))
						{
							_NodeProperties.push(6);
						}
						/* 7=right edge continuous */
						if(((!(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 - 1)),0,"" + "-1")) && !(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 + 1)),0,"" + "-1"))) && (!(tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 + 1)),0,"" + "-1")) && tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 - 1)),0,"" + "-1"))))
						{
							_NodeProperties.push(7);
						}
						/* 8=platform (middle) */
						if(((!(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 - 1)),0,"" + "-1")) && !(tileCollisionAt(Std.int(_RowNumber),Std.int((index1 + 1)),0,"" + "-1"))) && (tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 + 1)),0,"" + "-1") && tileCollisionAt(Std.int((_RowNumber + 1)),Std.int((index1 - 1)),0,"" + "-1"))))
						{
							_NodeProperties.push(8);
						}
					}
				}
			}
			/* Add connections */
			for(index0 in 0...Std.int(_NodesList.length))
			{
				_LoopIndex = asNumber(index0);
				propertyChanged("_LoopIndex", _LoopIndex);
				if((0 == asNumber(_NodeProperties[Std.int(index0)])))
				{
					_customEvent_JumpNodes();
					/* Fall */
					for(index1 in 0...Std.int(_NodesList.length))
					{
						if(((getTileWidth() == Math.abs((asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) - asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(0)])))) && (asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) > asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]))))
						{
							if(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(1)]) == (""))
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + index1));
							}
							else
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + (("" + ",") + ("" + index1))));
							}
							_MaxConnections += 1;
							propertyChanged("_MaxConnections", _MaxConnections);
							if((_MaxConnections == 2))
							{
								_MaxConnections = asNumber(0);
								propertyChanged("_MaxConnections", _MaxConnections);
								break;
							}
						}
					}
				}
				if((1 == asNumber(_NodeProperties[Std.int(index0)])))
				{
					_customEvent_JumpNodes();
				}
				if((2 == asNumber(_NodeProperties[Std.int(index0)])))
				{
					_customEvent_JumpNodes();
					/* Horizontal */
					if(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(1)]) == (""))
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (index0 + 1)));
					}
					else
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (("" + ",") + ("" + (index0 + 1)))));
					}
				}
				if((3 == asNumber(_NodeProperties[Std.int(index0)])))
				{
					_customEvent_JumpNodes();
					/* Fall */
					for(index1 in 0...Std.int(_NodesList.length))
					{
						if(((getTileWidth() == (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) - asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) && (asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) > asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]))))
						{
							if(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(1)]) == (""))
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + index1));
							}
							else
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + (("" + ",") + ("" + index1))));
							}
							break;
						}
					}
				}
				if((4 == asNumber(_NodeProperties[Std.int(index0)])))
				{
					/* Horizontal */
					if(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(1)]) == (""))
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (index0 + 1)));
					}
					else
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (("" + ",") + ("" + (index0 + 1)))));
					}
					_customEvent_JumpNodes();
					/* Fall */
					for(index1 in 0...Std.int(_NodesList.length))
					{
						if(((getTileWidth() == (asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) - asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) && (asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) > asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]))))
						{
							if(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(1)]) == (""))
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + index1));
							}
							else
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + (("" + ",") + ("" + index1))));
							}
							break;
						}
					}
				}
				if((5 == asNumber(_NodeProperties[Std.int(index0)])))
				{
					_customEvent_JumpNodes();
					/* Horizontal */
					if(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(1)]) == (""))
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (index0 - 1)));
					}
					else
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (("" + ",") + ("" + (index0 - 1)))));
					}
				}
				if((6 == asNumber(_NodeProperties[Std.int(index0)])))
				{
					_customEvent_JumpNodes();
					/* Fall */
					for(index1 in 0...Std.int(_NodesList.length))
					{
						if(((getTileWidth() == (asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) - asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) && (asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) > asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]))))
						{
							if(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(1)]) == (""))
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + index1));
							}
							else
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + (("" + ",") + ("" + index1))));
							}
							break;
						}
					}
				}
				if((7 == asNumber(_NodeProperties[Std.int(index0)])))
				{
					/* Horizontal */
					if(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(1)]) == (""))
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (index0 - 1)));
					}
					else
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (("" + ",") + ("" + (index0 - 1)))));
					}
					_customEvent_JumpNodes();
					/* Fall */
					for(index1 in 0...Std.int(_NodesList.length))
					{
						if(((getTileWidth() == (asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]) - asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(0)]))) && (asNumber(("" + ("" + _NodesList[Std.int(index1)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]) > asNumber(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(0)]).split(",")[Std.int(1)]))))
						{
							if(("" + ("" + _NodesList[Std.int(_LoopIndex)]).split("/")[Std.int(1)]) == (""))
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + index1));
							}
							else
							{
								_NodesList[Std.int(_LoopIndex)] = (("" + _NodesList[Std.int(_LoopIndex)]) + ("" + (("" + ",") + ("" + index1))));
							}
							break;
						}
					}
				}
				if((8 == asNumber(_NodeProperties[Std.int(index0)])))
				{
					/* Horizontal */
					if(("" + ("" + _NodesList[Std.int(index0)]).split("/")[Std.int(1)]) == (""))
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (("" + (index0 - 1)) + ("" + (("" + ",") + ("" + (index0 + 1)))))));
					}
					else
					{
						_NodesList[Std.int(index0)] = (("" + _NodesList[Std.int(index0)]) + ("" + (("" + ",") + ("" + (("" + (index0 - 1)) + ("" + (("" + ",") + ("" + (index0 + 1)))))))));
					}
					/* Jump */
					_customEvent_JumpNodesMiddle();
				}
			}
		}
		/* Split lists */
		for(item in cast(_NodesList, Array<Dynamic>))
		{
			_CoordinatesList.push(("" + item).split("/")[Std.int(0)]);
			_ConnectionsList.push(("" + item).split("/")[Std.int(1)]);
		}
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(_Debug)
				{
					g.translateToScreen();
					for(index0 in 0...Std.int(_NodesList.length))
					{
						g.fillColor = _NodeColor;
						g.strokeColor = _NodeColor;
						g.strokeSize = Std.int(0);
						g.fillCircle((asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(0)]) - getScreenX()), (asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(1)]) - getScreenY()), _Radius);
						g.drawString("" + _NodeProperties[Std.int(index0)], (asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(0)]) - getScreenX()), (asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(1)]) - getScreenY()));
						for(item in cast(("" + _ConnectionsList[Std.int(index0)]).split(","), Array<Dynamic>))
						{
							g.strokeColor = _LineColor;
							g.fillColor = _LineColor;
							g.strokeSize = Std.int(1);
							g.drawLine((asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(0)]) - getScreenX()), (asNumber(("" + _CoordinatesList[Std.int(index0)]).split(",")[Std.int(1)]) - getScreenY()), (asNumber(("" + _CoordinatesList[Std.int(asNumber(item))]).split(",")[Std.int(0)]) - getScreenX()), (asNumber(("" + _CoordinatesList[Std.int(asNumber(item))]).split(",")[Std.int(1)]) - getScreenY()));
						}
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}